'use strict';

const { rollup } = require('rollup');
const commonJS = require('rollup-plugin-commonjs');
const argv = require('minimist')(process.argv.slice(2));

function buildShared(dest, format) {
  return rollup({
    input: 'src/index.js',
    external(dependency) {
      if (dependency === 'src/index.js') {
        return false;
      }
    },
  })
    .then(({ write }) =>
      write({
        dest: format === 'cjs' ? `${dest}/index.cjs.js` : `${dest}/index.es.js`,
        format,
      })
    )
    .then(() => console.log('Utils built'))
    .catch(err => {
      if (err.code) {
        console.log(err.code);
        console.log(err);
      }
      process.exit(1);
    });
}

function build() {
  let format;
  if (argv.cjs) format = 'cjs';
  if (argv.es) format = 'es';
  return buildShared('dist', format);
}

build();
